package test.com.okooo.ap.hello;

import Ice.InitializationData;
import Ice.Properties;
import osgi.HelloPrx;
import osgi.HelloPrxHelper;

public class Client extends Ice.Application {
	class ShutdownHook extends Thread {
		public void run() {
			try {
				communicator().destroy();
			} catch (Ice.LocalException ex) {
				ex.printStackTrace();
			}
		}
	}

	private void menu() {
		System.out.println("usage:\n" + "t: say hello to jiangybc\n"
				+ "x: exit\n" + "?: help\n");
	}

	public int run(String[] args) {
		setInterruptHook(new ShutdownHook());
		HelloPrx hello = null;
		try {
			hello = HelloPrxHelper.checkedCast(communicator().stringToProxy(
					"HelloObject@HelloAdapters"));
		} catch (Ice.NotRegisteredException ex) {
			ex.printStackTrace();
		}
		if (hello == null) {
			System.err.println("couldn't find a hello object");
			return 1;
		}
		menu();
		java.io.BufferedReader in = new java.io.BufferedReader(
				new java.io.InputStreamReader(System.in));
		String line = null;
		do {
			try {
				System.out.print("==> ");
				System.out.flush();
				line = in.readLine();
				if (line == null) {
					break;
				}
				if (line.equals("t")) {
					System.out.println(hello.sayHello("jiangb"));
				} else if (line.equals("?")) {
					menu();
				} else {
					System.out.println("unknown command `" + line + "'");
					menu();
				}
			} catch (java.io.IOException ex) {
				ex.printStackTrace();
			} catch (Ice.LocalException ex) {
				ex.printStackTrace();
			}
		} while (!line.equals("x"));
		return 0;
	}

	public static void main(String[] args) {
		Client app = new Client();
		Properties props = Ice.Util.createProperties();
		props.setProperty("Ice.Default.Locator",
				"OkoooGrid/Locator:default -h grid.registry.com -p 4061");
		InitializationData id = new InitializationData();
		id.properties = props;
		int status = app.main("Client", new String[] {}, id);
		System.exit(status);
	}
}
